
package uk.co.badgersinfoil.jactionscript;

/**
 * Abstract superclass for all actions.
 * Most actions are defined as constants in the {@link ActionConstants}
 * interface.  Those Actions that operate on 'immediate data' (e.g.
 * IfJumpAction and its target address) cannot be constant; a new instance is
 * created each time these actions appears in an {@link ActionList}.
 */
public abstract class Action {
	private String mnemonic;

	public Action(String mnemonic) {
		this.mnemonic = mnemonic;
	}

	public String getMnemonic() {
		return mnemonic;
	}

	public abstract void accept(Visitor v) throws JASVisitorException;
}
