
package uk.co.badgersinfoil.jactionscript;

import java.util.List;

/**
 * Data for a {@link LookupTableAction}.
 */
public class LookupTable {
	private List values = new java.util.ArrayList();

	public LookupTable(String[] data) {
		for (int i=0 ; i<data.length ; i++) {
			values.add(data[i]);
		}
	}

	public boolean contains(String value) {
		return values.contains(value);
	}

	public String lookup(int index) {
		return (String)values.get(index);
	}

	/**
	 * Adds the given string to the lookup table if it does not already
	 * contain it.  Returns the index of the newly added entry if it was
	 * not already present, or the index of the existing entry otherwise.
	 */
	public int put(String value) {
		// TODO: return an indirect object rather than the actual
		// index to allow for table alterations other than append
		int i = values.indexOf(value);
		if (i >= 0) {
			return i;
		}
		values.add(value);
		return values.size()-1;
	}

	public int size() {
		return values.size();
	}

	public String[] toArray() {
		String[] result = new String[values.size()];
		values.toArray(result);
		return result;
	}
}
