
package uk.co.badgersinfoil.jactionscript.analysis;

import uk.co.badgersinfoil.jactionscript.*;
import java.util.List;

/**
 * Implements all methods of {@link StackListener} as no-ops
 */
public class NullStackListener implements StackListener {

	protected NullStackListener() { }

	public static final StackListener VALUE = new NullStackListener();

	public void visitHandle(ActionHandle handle) { }

	public void visitEnd(ActionList list) { }

	public void visitADD(Action action, Operand left, Operand right, Operand result) { }
	public void visitAND(Action action, Operand left, Operand right, Operand result) { }
	public void visitASCII_TO_CHAR(Action action, Operand val, Operand result) { }
	public void visitASCII_TO_CHAR_MB(Action action, Operand val, Operand result) { }
	public void visitBIT_AND(Action action, Operand left, Operand right, Operand result) { }
	public void visitBIT_OR(Action action, Operand left, Operand right, Operand result) { }
	public void visitBIT_XOR(Action action, Operand left, Operand right, Operand result) { }
//	public void visitCALL(Action action) { }
	public void visitCALL_FUNCTION(Action action, Operand name, List args, Operand result) { }
	public void visitCALL_METHOD(Action action, Operand name, List args, Operand result) { }
	public void visitCHAR_MB_TO_ASCII(Action action, Operand val, Operand result) { }
	public void visitCHAR_TO_ASCII(Action action, Operand val, Operand result) { }
//	public void visitCLONE_SPRITE(Action action) { }
	public void visitCONCAT(Action action, Operand left, Operand right, Operand result) { }
	public void visitCONVERT_TO_NUMBER(Action action, Operand val, Operand result) { }
	public void visitCONVERT_TO_STRING(Action action, Operand val, Operand result) { }
	public void visitDECREMENT(Action action, Operand val, Operand result) { }
	public void visitDEFINE_LOCAL(Action action, Operand name) { }
	public void visitDEFINE_LOCAL_VALUE(Action action, Operand name, Operand value) { }
	public void visitDELETE_PROPERTY(Action action, Operand name, Operand obj, Operand result) { }
	public void visitDELETE_THREAD_VARS(Action action, Operand name) { }
	public void visitDIVIDE(Action action, Operand left, Operand right, Operand result) { }
	public void visitDUPLICATE(Action action, Operand val, Operand result1, Operand result2) { }
	public void visitEND_DRAG(Action action) { }
	public void visitENUMERATE(Action action, Operand name, List slots) { }
	public void visitENUMERATE_OBJECT(Action action, Operand obj, List slots) { }
	public void visitEQUALS(Action action, Operand left, Operand right, Operand result) { }
	public void visitGET_MEMBER(Action action, Operand name, Operand obj, Operand result) { }
	public void visitGET_PROPERTY(Action action, Operand index, Operand target, Operand result) { }
//	public void visitGET_TARGET_PATH(Action action) { }
	public void visitGET_TIME(Action action, Operand time) { }
	public void visitGET_URL2(GetURL2Action action, Operand target, Operand url) { }
	public void visitGET_URL(GetURLAction action) { }
	public void visitGET_VARIABLE(Action action, Operand name, Operand result) { }
	public void visitGOTO_FRAME2(GotoFrame2Action action, Operand frame) { }
	public void visitGOTO_FRAME(GotoFrameAction action) { }
//	public void visitGOTO_LABEL(GotoLabelAction action) { }
	public void visitGREATER_THAN(Action action, Operand right, Operand left, Operand result) { }
	public void visitIF_JUMP(IfJumpAction action, Operand condition) { }
	public void visitINCREMENT(Action action, Operand val, Operand result) { }
//	public void visitINIT_ARRAY(Action action) { }
//	public void visitINIT_OBJECT(Action action) { }
	public void visitINSTANCE_OF(Action action, Operand ctor, Operand obj, Operand result) { }
	public void visitJUMP(JumpAction action) { }
	public void visitLESS_THAN(Action action, Operand left, Operand right, Operand result) { }
	public void visitLOOKUP(LookupAction action, Operand result) { }
	public void visitLOOKUP_TABLE(LookupTableAction action) { }
	public void visitMODULO(Action action, Operand left, Operand right, Operand result) { }
	public void visitMULTIPLY(Action action, Operand left, Operand right, Operand result) { }
//	public void visitNEW_METHOD(Action action) { }
	public void visitNEW_OBJECT(Action action, Operand name, List args, Operand result) { }
	public void visitNEXT_FRAME(Action action) { }
	public void visitNOT(Action action, Operand val, Operand result) { }
	public void visitOR(Action action, Operand left, Operand right, Operand result) { }
	public void visitPLAY(Action action) { }
	public void visitPOP(Action action) { }
	public void visitPREV_FRAME(Action action) { }
	public void visitPUSH(PushAction action, List list) { }
	public void visitRANDOM_NUMBER(Action action, Operand max, Operand result) { }
	public void visitREMOVE_SPRITE(Action action, Operand target) { }
	public void visitRETURN_VALUE(Action action, Operand returnVal) { }
	public void visitSET_MEMBER(Action action, Operand value, Operand name, Operand object) { }
	public void visitSET_PROPERTY(Action action, Operand value, Operand index, Operand target) { }
	public void visitSET_TARGET_2(Action action, Operand target) { }
	public void visitSET_TARGET(SetTargetAction action) { }
	public void visitSET_VARIABLE(Action action, Operand name, Operand value) { }
	public void visitSHIFT_LEFT(Action action, Operand count, Operand value, Operand result) { }
	public void visitSHIFT_RIGHT(Action action, Operand count, Operand value, Operand result) { }
	public void visitSHIFT_RIGHT_UNSIGNED(Action action, Operand count, Operand value, Operand result) { }
	public void visitSTART_DRAG(Action action, Operand target, Operand lookCentre, DragBox constraintBox) { }
	public void visitSTART_FUNCTION(StartFunctionAction action, Operand fn) { }
//	public void visitSTART_WITH(Action action) { }
	public void visitSTOP(Action action) { }
	public void visitSTOP_SOUNDS(Action action) { }
	public void visitSTORE_IN_REGISTER(StoreInRegisterAction action, Operand val) { }
	public void visitSTRICT_EQUALS(Action action, Operand left, Operand right, Operand result) { }
	public void visitSTRING_EQUALS(Action action, Operand left, Operand right, Operand result) { }
	public void visitSTRING_GREATER_THAN(Action action, Operand left, Operand right, Operand result) { }
	public void visitSTRING_LENGTH(Action action, Operand val, Operand result) { }
	public void visitSTRING_LENGTH_MB(Action action, Operand val, Operand result) { }
	public void visitSTRING_LESS_THAN(Action action, Operand left, Operand right, Operand result) { }
	public void visitSUBSTRING(Action action, Operand count, Operand index, Operand val, Operand result) { }
//	public void visitSUBSTRING_MB(Action action) { }
	public void visitSUBTRACT(Action action, Operand left, Operand right, Operand result) { }
	public void visitSWAP(Action action, Operand first, Operand second) { }
	public void visitTOGGLE_QUALITY(Action action) { }
	public void visitTO_INTEGER(Action action, Operand val, Operand result) { }
	public void visitTRACE(Action action, Operand val) { }
	public void visitTYPED_ADD(Action action, Operand left, Operand right, Operand result) { }
	public void visitTYPED_EQUALS(Action action, Operand left, Operand right, Operand result) { }
	public void visitTYPED_LESS_THAN(Action action, Operand left, Operand right, Operand result) { }
	public void visitTYPE_OF(Action action, Operand val, Operand result) { }
//	public void visitUNKNOWN(UnknownAction action) { }
//	public void visitWAIT_FOR_FRAME(WaitForFrameAction action) { }
//	public void visitWAIT_FOR_FRAME_2(WaitForFrame2Action action) { }
}
