
package uk.co.badgersinfoil.jactionscript.analysis;

import uk.co.badgersinfoil.jactionscript.*;
import java.util.List;
import java.util.Map;
import java.util.HashMap;


/**
 * FIXME: this is just a toy implementation, taking no account of scoping rules
 */
public class VariableProcessor extends FilterStackListener {
	private Map vars = new HashMap();

	public VariableProcessor(StackListener listener) {
		super(listener);
	}

	public void visitDEFINE_LOCAL(Action action, Operand name)
		throws JASVisitorException
	{
		if (name.knownValue()) {
			vars.put(name.getValue(), Operand.mkundefined());
		} else {
			// TODO: invalidate context as we don't know what
			//       var may have been overwritten
		}
		super.visitDEFINE_LOCAL(action, name);
	}
	
	public void visitDEFINE_LOCAL_VALUE(Action action, Operand name, Operand value)
		throws JASVisitorException
	{
		if (name.knownValue()) {
			// TODO: dup the value?
			vars.put(name.getValue(), value);
		} else {
			// TODO: invalidate context as we don't know what
			//       var may have been overwritten
		}
		super.visitDEFINE_LOCAL_VALUE(action, name, value);
	}

	public void visitDELETE_THREAD_VARS(Action action, Operand name)
		throws JASVisitorException
	{
System.out.println("DELETE_THREAD_VARS "+name+" (what does it mean?)");
		super.visitDELETE_THREAD_VARS(action, name);
	}

	public void visitGET_VARIABLE(Action action, Operand name, Operand result)
		throws JASVisitorException
	{
		if (name.knownValue()) {
			Operand value = (Operand)vars.get(name.getValue());
			if (value == null) {
				// we came up with no value for this variable.
				// since we make no attept to prepactionulate the
				// context with whatever Flash normaly does,
				// we say the value is 'unknown' rather than
				// 'undefined', since the Flash player, the
				// variable may actualy be defined
				
				// [result will already be undefined; don't
				// change it]
			} else {
				result.setType(value.getType());
				result.setValue(value.getValue());
			}
		} else {
			// else, is there anything interesting we might want
			// to note about a read of an unknown var?
		}
		super.visitGET_VARIABLE(action, name, result);
	}

	public void visitSET_VARIABLE(Action action, Operand name, Operand value)
		throws JASVisitorException
	{
		if (name.knownValue()) {
			// TODO: dup the value?
			vars.put(name.getValue(), value);
		} else {
			// TODO: invalidate context as we don't know what
			//       var may have been overwritten
		}
		super.visitSET_VARIABLE(action, name, value);
	}
}
