
package uk.co.badgersinfoil.jactionscript.example;

import uk.co.badgersinfoil.jactionscript.GetURL2Action;
import uk.co.badgersinfoil.jactionscript.GetURLAction;
import uk.co.badgersinfoil.jactionscript.Visitor;
import uk.co.badgersinfoil.jactionscript.analysis.SimpleStackSimulator;
import uk.co.badgersinfoil.jactionscript.analysis.Operand;
import uk.co.badgersinfoil.jactionscript.analysis.NullStackListener;
import uk.co.badgersinfoil.jactionscript.analysis.DebugStackListener;

import com.anotherbigidea.flash.readers.TagParser;
import com.anotherbigidea.flash.readers.SWFReader;

import java.io.IOException;

/**
 * Command-line program to print the links in an SWF file given as the
 * command-line argument.
 */
public class LinkExtractor {
	public static void main(String[] args) throws IOException {
		GetUrlStackListener l = new GetUrlStackListener();
		//DebugStackListener d = new DebugStackListener(l);
		SimpleStackSimulator v = new SimpleStackSimulator(l);
		SWFActionExtract extract = new SWFActionExtract(v);
		TagParser parser = new TagParser(extract);
		SWFReader reader = new SWFReader(parser, args[0]);
		reader.readFile();
	}

	private static class GetUrlStackListener extends NullStackListener {
		public void visitGET_URL2(GetURL2Action action,
		                          Operand target, Operand url)
		{
			if (url.knownValue()) {
				System.out.println("GET_URL2: "+url.getValue());
			} else {
				System.out.println("GET_URL2: (unknown)");
			}
		}
		public void visitGET_URL(GetURLAction action) {
			System.out.println("GET_URL: "+action.getURL());
		}
	}
}
