
package uk.co.badgersinfoil.jactionscript.example;

import uk.co.badgersinfoil.jactionscript.javaswf.BytecodeSWFActions;
import uk.co.badgersinfoil.jactionscript.javaswf.SWFActionsVisitor;
import uk.co.badgersinfoil.jactionscript.ActionList;
import uk.co.badgersinfoil.jactionscript.Visitor;
import uk.co.badgersinfoil.jactionscript.JASVisitorException;

import com.anotherbigidea.flash.interfaces.SWFTagTypes;
import com.anotherbigidea.flash.interfaces.SWFActions;
import com.anotherbigidea.flash.writers.SWFTagTypesImpl;
import com.anotherbigidea.flash.structs.Matrix;
import com.anotherbigidea.flash.structs.AlphaTransform;

import java.io.IOException;
import java.util.Vector;

public class SWFActionExtract extends SWFTagTypesImpl {
	private Visitor visitor;

	public SWFActionExtract(Visitor v) {
		super(null);
		visitor = v;
	}

	public SWFActions tagDoAction() throws IOException {
		return new BytecodeExtractSWFActions(visitor);
	}
           
	public SWFActions tagDoInitAction(int spriteId) throws IOException {
		return new BytecodeExtractSWFActions(visitor);
	}

	public SWFActions tagPlaceObject2(boolean isMove, int clipDepth,
	                                  int depth, int charId, Matrix matrix,
	                                  AlphaTransform cxform, int ratio,
	                                  String name, int clipActionFlags)
		throws IOException
	{
		return new BytecodeExtractSWFActions(visitor);
	}

	public SWFActions tagDefineButton(int id, Vector buttonRecords)
		throws IOException
	{
		return new BytecodeExtractSWFActions(visitor);
	}

	public SWFActions tagDefineButton2(int id, boolean trackAsMenu,
	                                   Vector buttonRecord2s)
		throws IOException
	{
		return new BytecodeExtractSWFActions(visitor);
	}

	public SWFTagTypes tagDefineSprite(int id)
		throws IOException
	{
		return new SWFActionExtract(visitor);
	}


	private static class BytecodeExtractSWFActions extends BytecodeSWFActions
	{
		private Visitor visitor;

		public BytecodeExtractSWFActions(Visitor v) {
			visitor = v;
		}

		public void start(int flags) throws IOException {
//System.out.println("* * *start() : "+this);
			super.start(flags);
		}
           
		public void start(int flags, int keycode) throws IOException {
//System.out.println("* * * start() : "+this);
			super.start(flags, keycode);
		}

		public void done() throws IOException {
//System.out.println("* * * done() : "+this);
			super.done();
		}

		public void doneIt() throws IOException {
			//SWFActionsVisitor v = new SWFActionsVisitor(dest);
			try {
				ActionList list = getList();
				list.accept(visitor);
			} catch (JASVisitorException e) {
				Throwable t = e.getTarget();
				if (t instanceof IOException) {
					throw (IOException)t;
				} else if (t instanceof RuntimeException) {
					throw (RuntimeException)t;
				} else {
					// TODO: better debugging info need
					throw new IOException(t.getMessage());
				}
			}
		}

		public void end() throws IOException {
			doneIt();
//System.out.println("* * * end() : "+this);
			super.end();
		}

		public void endBlock() throws IOException {
//System.out.println("* * * endBlock() : "+this);
			super.endBlock();
		}
	}
}
