
package uk.co.badgersinfoil.jactionscript.example;

import uk.co.badgersinfoil.jactionscript.javaswf.BytecodeSWFActions;
import uk.co.badgersinfoil.jactionscript.ActionList;
import uk.co.badgersinfoil.jactionscript.javaswf.SWFActionsVisitor;
import uk.co.badgersinfoil.jactionscript.JASVisitorException;


import com.anotherbigidea.flash.interfaces.SWFTagTypes;
import com.anotherbigidea.flash.interfaces.SWFActions;
import com.anotherbigidea.flash.writers.SWFTagTypesImpl;
import com.anotherbigidea.flash.structs.Matrix;
import com.anotherbigidea.flash.structs.AlphaTransform;

import java.io.IOException;
import java.util.Vector;

/**
 * This doesn't work yet.
 */
public class SWFActionRewrite extends SWFTagTypesImpl {
	public SWFActionRewrite(SWFTagTypes tags) {
		super(tags);
	}

	public SWFActions tagDoAction() throws IOException {
		SWFActions dest = super.tagDoAction();
		return new BytecodeRewriteSWFActions(dest);
	}
           
	public SWFActions tagDoInitAction(int spriteId) throws IOException {
		SWFActions dest = super.tagDoInitAction(spriteId);
		return new BytecodeRewriteSWFActions(dest);
	}

	public SWFActions tagPlaceObject2(boolean isMove, int clipDepth,
	                                  int depth, int charId, Matrix matrix,
	                                  AlphaTransform cxform, int ratio,
	                                  String name, int clipActionFlags)
		throws IOException
	{
		SWFActions dest = super.tagPlaceObject2(isMove, clipDepth,
		                                        depth, charId, matrix,
		                                        cxform, ratio,
		                                        name, clipActionFlags);
		return new BytecodeRewriteSWFActions(dest);
	}

	public SWFActions tagDefineButton(int id, Vector buttonRecords)
		throws IOException
	{
		SWFActions dest = super.tagDefineButton(id, buttonRecords);
		return new BytecodeRewriteSWFActions(dest);
	}

	public SWFActions tagDefineButton2(int id, boolean trackAsMenu,
	                                   Vector buttonRecord2s)
		throws IOException
	{
		SWFActions dest = super.tagDefineButton2(id, trackAsMenu,
		                                        buttonRecord2s);
		return new BytecodeRewriteSWFActions(dest);
	}

	public SWFTagTypes tagDefineSprite(int id)
		throws IOException
	{
		return new SWFActionRewrite(super.tagDefineSprite(id));
	}


	private static class BytecodeRewriteSWFActions extends BytecodeSWFActions
	{
		private SWFActions dest;

		public BytecodeRewriteSWFActions(SWFActions dest) {
			super();
			this.dest = dest;
		}

		public void start(int flags) throws IOException {
			super.start(flags);
			dest.start(flags);
//System.out.println("start() : "+this);
		}
           
		public void start(int flags, int keycode) throws IOException {
			super.start(flags, keycode);
			dest.start(flags, keycode);
//System.out.println("start() : "+this);
		}

		public void done() throws IOException {
			super.done();
			dest.done();
//System.out.println("done() : "+this);
		}

		public void doneIt() throws IOException {
			SWFActionsVisitor v = new SWFActionsVisitor(dest);
			try {
				ActionList list = getList();
				// TODO: need callback here!
				list.accept(v);
			} catch (JASVisitorException e) {
				Throwable t = e.getTarget();
				if (t instanceof IOException) {
					throw (IOException)t;
				} else if (t instanceof RuntimeException) {
					throw (RuntimeException)t;
				} else {
					// TODO: better debugging info need
					throw new IOException(t.getMessage());
				}
			}
		}

		public void end() throws IOException {
			doneIt();
			super.end();
			dest.end();
//System.out.println("end() : "+this);
		}
	}
}
