

package uk.co.badgersinfoil.jactionscript.example.peephole;


import java.util.List;

import uk.co.badgersinfoil.jactionscript.ActionList;
import uk.co.badgersinfoil.jactionscript.ActionHandle;

public class Peephole {
	private List transforms = new java.util.ArrayList();

	public void optimize(ActionList list) {
		Transform[] transArray = new Transform[transforms.size()];
		transforms.toArray(transArray);
		int maxTransform = maxTransformMatchLength(transArray);
		ActionHandle currentHandle = list.first();
		OPCODES: for (int pos=0 ; pos<list.length() ; pos++) {
			for (int i=transArray.length-1 ; i>=0 ; --i) {
				Transform trans = transArray[i];
				if (trans.tryReduce(list, currentHandle)) {
					int rewind = Math.min(pos + 1,
					                      maxTransform);
					pos -= rewind;
					currentHandle = list.get(pos+1);
					continue OPCODES;
				}
			}
			currentHandle = currentHandle.getNext();
		}
	}

	private static int maxTransformMatchLength(Transform[] transArray) {
		int max = 0;
		for (int i=transArray.length-1 ; i>=0 ; --i) {
			Transform trans = transArray[i];
			if (trans.matchLength() > max) {
				max = trans.matchLength();
			}
		}
		return max;
	}

	public void addTransform(Transform trans) {
		transforms.add(trans);
	}
}
