
package uk.co.badgersinfoil.jactionscript.example.peephole;

import java.util.List;

import uk.co.badgersinfoil.jactionscript.ActionList;
import uk.co.badgersinfoil.jactionscript.ActionHandle;

public abstract class Transform {
	private List matches  = new java.util.ArrayList();


	public void addActionMatch(ActionMatch match) {
		matches.add(match);
	}


	/**
	 * @return true if the list was modified
	 */
	public boolean tryReduce(ActionList list, ActionHandle startAction) {
		ActionHandle current = startAction;
		for (int i=0 ; i<matches.size() ; i++) {
			if (i>0 && current.hasTargeters()) {
				// don't mess with a sequence of opcodes that
				// have a jump into the middel of them
				return false;
			}
			ActionMatch match = (ActionMatch)matches.get(i);
			if (!match.matches(current)) {
				return false;
			}
			current = current.getNext();
		}

		doReduce(list, startAction);
		return true;
	}


	public abstract void doReduce(ActionList list, ActionHandle startAction);


	/**
	 * Returns the number of Actions this XForm will match.
	 */
	public int matchLength() {
		return matches.size();
	}
}

